<?php	
	function printArray($str){
		print "<pre>";
			print_r($str);
		print "</pre>";
	}
	function redirect($url){
		header("Location:".$url);
		exit;
	}
	function needLogin(){
		global $global_config;
		if($_SESSION['SESS_CPC_USERID']==''){
			redirect($global_config["SiteLivePath"].'login');
		}
	}
		
	function getRandomNumbers($length=10){
		srand(date("s")); 
		$possible_charactors = "abcdefghijklmnopqrstuvwxyz1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ"; 
		$string = ""; 
		while(strlen($string)<$length){ 
			$string .=substr($possible_charactors, rand()%((strlen($possible_charactors))),1); 
		} 
		return(uniqid($string)); 
	}
	
	function showJsonResults($arr) {
		echo array2json($arr);
	}
			
	function array2json($arr) {
		$parts = array();
		$is_list = false;   
		//Find out if the given array is a numerical array
		$keys = array_keys($arr);
		$max_length = count($arr)-1;
		if($arr) {
			if(($keys[0] == 0) and ($keys[$max_length] == $max_length)) {
				//See if the first key is 0 and last key is length - 1
				$is_list = true;
				for($i=0; $i<count($keys); $i++) {
					//See if each key correspondes to its position                  
					if($i != $keys[$i]) { //A key fails at position check.
						$is_list = false; //It is an associative array.
						break;
				   }
			   }
			}
		}
		
		foreach($arr as $key=>$value) {
			if(is_array($value)) {
				//Custom handling for arrays
				if($is_list) $parts[] =	array2json($value); /* :RECURSION: */
				else $parts[] = '"' . $key . '":' . array2json($value); /* :RECURSION: */
			} else {
				$str = '';
				if(!$is_list) $str = '"' . $key . '":';
						   //Custom handling for multiple data types
				if(is_numeric($value)) $str .= '"'.$value.'"'; //Numbers
				elseif($value === false) $str .= 'false'; //The booleans
				elseif($value === true) $str .= 'true';
				else $str .= '"' . $value . '"'; //All other things
				// :TODO: Is there any more datatype we should be in the lookout for? (Object?)
				$parts[] = $str;
		   }
		}
		$json = implode(',',$parts);
		
		if($is_list) return  '[' . $json . ']';//Return associative JSON
		return  '{' . $json . '}';//Return associative JSON
	}
	    function get_extension($filename){
        $str=explode('/',$filename);
        $len=count($str);
        $str2=explode('.',$str[($len-1)]);
        $len2=count($str2);
        $ext=$str2[($len2-1)];
        return $ext;
    }

 	function doGetTableListing($strTable,$strWhereClause=NULL,$orderBy=NULL,$strSelect='*',$groupBy=NULL){
		global $objCommon,$global_config;
		$sql 		=	"SELECT $strSelect FROM ".$strTable." $strWhereClause $groupBy $orderBy";
		$strResults =	$objCommon->getSelectQuery($sql);
		return $strResults;
	}
		
	function doGetTableSingleRecord($strTable,$strWhereClause=NULL,$strSelect='*'){
		global $objCommon,$global_config;
		$sql 		=	"SELECT $strSelect FROM ".$strTable." $strWhereClause ";
		$strResults =	$objCommon->getSelectQuery($sql);
 		return $strResults[0];
	}
		
	function doGetTableCount($strTable,$strWhereClause=NULL){
		global $objCommon,$global_config;
		$sql 		=	"SELECT count(*) as TotalCnt FROM ".$strTable." $strWhereClause ";
		$strResults =	$objCommon->getSelectQuery($sql);
		return $strResults[0]['TotalCnt'];
	}
	
 	function doDeleteById($strTablename,$strFieldName,$strFieldValue) {
		global $objCommon,$global_config;
		$sql	= "DELETE FROM ".$strTablename." WHERE ".$strFieldName." = '".$strFieldValue."'";
		$objCommon->ExecuteQry($sql);
	}
	
	function createthumb($input_file_name, $output_filename, $new_w, $new_h='') {
	if (preg_match("/(jpg|jpeg)$/i",$input_file_name)){
		$src_img = imagecreatefromjpeg($input_file_name);
	} else if (preg_match("/png$/i",$input_file_name)){
		$src_img = imagecreatefrompng($input_file_name);
	} else if(preg_match("/bmp$/i",$input_file_name)){
		 $src_img = imagecreatefromjpeg($input_file_name);
	} else if(preg_match("/gif$/i",$input_file_name)){
		$src_img = imagecreatefromgif($input_file_name);
	} else {
		throw(new Exception("ERROR: Cant work with file $input_file_name becuase its an unsupported file type for this function."));
	}

	if( $src_img == false ) {
		throw(new Exception("ERROR: Unabel to open image file $input_file_name"));
	}

	$old_x = imageSX($src_img);
	$old_y = imageSY($src_img);

	if( $new_h == 0 ) {
		$thumb_w = $new_w;
				$thumb_h = $old_y * ($new_w / $old_x);

	} else if( $new_w == 0 ) {
		$thumb_h = $new_h;
				$thumb_w = $old_x * ($new_h / $old_y);
	} else {
		if ($old_x > $old_y) 	{
			$thumb_w = $new_w;
			$thumb_h = $old_y * ($new_h/$old_x);
		} else if ($old_x < $old_y) {
			$thumb_w = $old_x * ($new_w/$old_y);
			$thumb_h = $new_h;
		} else if ($old_x == $old_y) {
			$thumb_w = $new_w;
			$thumb_h = $new_h;
		}
	}

	$dst_img = ImageCreateTrueColor($thumb_w,$thumb_h);
	imagecopyresampled($dst_img,$src_img,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y); 

	if (preg_match("/png$/i",$input_file_name)){
		imagepng($dst_img,$output_filename); 
	} else {
		imagejpeg($dst_img,$output_filename); 
	}
	return $output_filename;
	imagedestroy($dst_img); 
	imagedestroy($src_img); 
}

function getFileExtension($fn){
	$str=explode('/',$fn);
	$len=count($str);
	if (strpos($str[($len-1)],'.') === False) return False; 
	$str2=explode('.',$str[($len-1)]);
	$len2=count($str2);
	$ext=$str2[($len2-1)];
	return $ext;
}
?>