<?php
/**
 * Plugin Name: ADASC Slider
 * Description: ADASC Custom Slider Admin Module
 * Version: 0.0.1
*/

	register_activation_hook(__FILE__,'slider_plugin_install');
	//register_deactivation_hook( __FILE__, 'my_plugin_remove_database');
	//register_deactivation_hook(__FILE__,'slider_plugin_uninstall');

	function slider_plugin_install(){
		global $wpdb;

		$tablesliderType		=	$wpdb->prefix."ada_slider_type";
		$structuresliderType	=	"CREATE TABLE IF NOT EXISTS $tablesliderType (
										`id` int(11) NOT NULL AUTO_INCREMENT,
										`title_name` VARCHAR(255) NOT NULL,
										`time_interval` int(11) NOT NULL,
										`slider_nav` ENUM('enable','disable') NOT NULL DEFAULT 'enable',
										`added_date` DATETIME NOT NULL,
										PRIMARY KEY (`id`)
									)";
		$wpdb->query($structuresliderType);
	
		$tablesliderimage		=	$wpdb->prefix."ada_slider_image";
		$structuresliderimage	=	"CREATE TABLE IF NOT EXISTS $tablesliderimage (
										`slider_id` int(11) NOT NULL AUTO_INCREMENT,
										`slider_type` int(11) NOT NULL,
										`slider_image` VARCHAR(255) NOT NULL,
										`title` VARCHAR(255) NOT NULL,
										`alt_text` VARCHAR(255) NOT NULL,
										`description` TEXT NOT NULL,
									`image_position` ENUM('default','center','center_top','center_bottom') NOT NULL DEFAULT 'default',
										`sort_order` int(11) NOT NULL,
										`added_date` DATETIME NOT NULL,
										PRIMARY KEY (`slider_id`)
									)";
		$wpdb->query($structuresliderimage);							
	}


	/*function my_plugin_remove_database() {
	    global $wpdb;

	    $tablesliderType		=	$wpdb->prefix."ada_slider_type";
		$structuresliderType	=	"DROP TABLE IF EXISTS $tablesliderType";
		$wpdb->query($structuresliderType);

		$tablesliderimage		=	$wpdb->prefix."ada_slider_image";
		$structuresliderimage	=	"DROP TABLE IF EXISTS $tablesliderimage";
		$wpdb->query($structuresliderimage);

	    delete_option("my_plugin_db_version");
	} */  
	
	add_action('admin_menu','slider_control');
	function slider_control(){
		$tmp	=	basename(dirname(__FILE__));
		add_menu_page('ADASC Slider','ADASC Slider','',__FILE__,'','');
		add_submenu_page(__FILE__,'View ADASC Slider','View ADASC Slider','0','sliderimage','sliderimage');
		add_submenu_page(__FILE__,'Add Slider','Add Slider','0','sliderimage&action=add','sliderimage&action=add');
		add_submenu_page(__FILE__,'Settings','Settings','0','sliderimage&action=settings','sliderimage&action=settings');
	}	

	function sliderimage(){
		include('sliderimage.php');
	}
	function load_wp_media_files1() {
		wp_enqueue_media();
	}
	add_action( 'admin_enqueue_scripts', 'load_wp_media_files1' );

	/*function load_admin_things() {
	    wp_enqueue_script('media-upload');
	    wp_enqueue_script('thickbox');
	    wp_enqueue_style('thickbox');
	}

	add_action( 'admin_enqueue_scripts', 'load_admin_things' );*/

	function demo_handler( $atts ) {
    extract( shortcode_atts( array(
        'id' => '',
    ), $atts, 'ada_slider' ) );

	    $demolph_output = demoplug_function( $id );  
	    return $demolph_output;
	}
	add_shortcode( "ada_slider", "demo_handler" );

	function demoplug_function($id) { 
		global $wpdb;
		$strSliderSql		=	"SELECT A.*,B.* FROM ".$wpdb->prefix."ada_slider_image as A LEFT JOIN ".$wpdb->prefix."ada_slider_type as B ON A.slider_type = B.id WHERE A.slider_type = '".$id."' order by A.sort_order ASC"; 
		$strSliderResults 	=	$wpdb->get_results($strSliderSql);	
		
		?>
		<style>
			@-ms-viewport{width:device-width}
			@-o-viewport{width:device-width}
			@viewport{width:device-width}
			.visuallyhidden,
			footer h2{border:0;clip:rect(0 0 0 0);
			height:1px;
			margin:-1px;
			overflow:hidden;
			padding:0;
			position:absolute;
			width:1px}
			.visuallyhidden.hasfocus,
			footer h2.hasfocus,

			.visuallyhidden.focusable:active,
			footer h2.focusable:active,

			.visuallyhidden.focusable:focus,
			footer h2.focusable:focus{clip:auto;height:auto;margin:0;overflow:visible;position:static;width:auto}

			html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}body{margin:0}a{background:transparent}a:focus{outline:thin dotted}a:active,a:hover{outline:0}h1{font-size:2em;margin:0.67em 0}abbr[title]{border-bottom:1px dotted}b,strong{font-weight:bold}dfn{font-style:italic}hr{box-sizing:content-box;height:0}mark{background:#ff0;color:#000}code,kbd,pre,samp{font-family:monospace, serif;font-size:1em}pre{white-space:pre-wrap}q{quotes:"\201C" "\201D" "\2018" "\2019"}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}
		</style>
		<?php 
			$html = '<div class="slider-ada-width">';
			$html .= '<div id="c" class="carousel">';
			$html .= '<input type="hidden" name="slider_head" id="slider_head" value="Slideshow">';
			$html .= '<span class="sr-only">Slideshow</span>';
			$html .= '<input type="hidden" name="ada_alider_hd" id="ada_alider_hd" value="1">';

			$html .= '<ul class="position-image">';
			
			if($strSliderResults){
				foreach ($strSliderResults as $value) {
					switch ($value->image_position) {
						case 'center':
							$class = "center_slidepostion";
							break;
						case 'center_top':
							$class = "center_top_slidepostion";
							break;
						case 'center_bottom':
							$class = "center_bottom_slidepostion";
							break;
						default:
							$class = "";
						break;
					}
					if($value->slider_nav == 'disable') {
						$class1 = "disable";
						$start  = "start-btn";
					} 
					if($value->image_position !='default'){ 
						$html .= '<li class="slide" aria-label="gallery" tabindex="0">';
						$html .= '<img src="'.$value->slider_image.'" alt="'.$value->alt_text.'" class="'.$class.'">';
						if($value->title) {
							$html .= '<h4>"'.$value->title.'"</h4>';
						}
						if($value->description) {
							$html .= '<span style="display:block; margin-top:10px;">"'.$value->description.'"</span>';
						}
						$html .= '</li>';
					} else {
						$html .= '<li class="slide" aria-label="gallery" tabindex="0" id="image-height">';
						$html .= '<img src="'.$value->slider_image.'" alt="'.$value->alt_text.'">';
						if($value->title) {
							$html .= '<h4>"'.$value->title.'"</h4>';
						}
						if($value->description) {
							$html .= '<span style="display:block; margin-top:10px;">"'.$value->description.'"</span>';
						}
						$html .= '</li>';

					}
				}
			?>
			<link rel="stylesheet" href="<?php echo plugins_url(); ?>/ada-slider/css/sliders/slider.css"/>
			<style type="text/css">
				.slidenav button:focus{
				border: 2px dotted red!important;
		    	background-color: red!important;
			}
			[aria-label="gallery"]:focus {
				outline: 2px solid DodgerBlue;
				outline-offset: -6px; 
			}
			.screen-reader-text {
			  border: 0;
			  clip: rect(1px, 1px, 1px, 1px);
			  clip-path: inset(50%);
			  height: 1px;
			  margin: -1px;
			  overflow: hidden;
			  padding: 0;
			  position: absolute !important;
			  width: 1px;
			  word-wrap: normal !important;
			}
			.screen-reader-text {
			    position: absolute !important;
			    left: -999em;
			}
			.screen-reader-text:focus {
			  background-color: #eee;
			  clip: auto !important;
			  clip-path: none;
			  color: #444;
			  display: block;
			  font-size: 1em;
			  height: auto;
			  left: 5px;
			  line-height: normal;
			  padding: 15px 23px 14px;
			  text-decoration: none;
			  top: 5px;
			  width: auto;
			  z-index: 100000; /* Above WP toolbar. */
			}
			/*.hide-navigation ul.slidenav{
				display: none!important;
			}*/
			.hide-navigation .carousel.with-slidenav .slide{
				border: 1px solid #fff!important;
			}
			.hide-navigation .slidenav button{
			    height: 14px!important;
	            width: 14px!important;
			}
			.hide-navigation .slidenav button.current {
	            height: 14px!important;
	        }
	        
	        .hide-navigation .slidenav button.start-in{
	            height: 20px!important;
	            width: 20px!important;
	        }
	        
	        .hide-navigation .carousel li{
	            margin:0 2px!important;
	        }
			.slider-ada-width button.start-in[data-action="stop"]:before {
				content: "\f04c"!important;
			}
			.slider-ada-width button.start-in[data-action="start"]:before {
				content: "\f04b"!important;
			}

			ul.position-image li{
				height: 100vh;
			}
			ul.position-image #image-height{
				height: 100%!important;
				min-height: auto;
			}
			/*#center_top_slidepostion{
				height: 100vh;
			}
			#center_bottom_slidepostion{
				height: 100vh;
			}*/
			.active .slide.current{
				position: relative;
			    width: 100%;
			    height: 100%;
			    overflow: hidden;
			    margin-bottom: 20px;
			    min-height: 500px;
			}
			img.center_slidepostion{
				min-height:100%;
			    min-width:100%;
			    width:auto;
			    height:auto;
			    position: absolute;
			    left: 50%;
			    top: 50%;
			    transform: translate(-50%,-50%);
			}
			img.center_top_slidepostion{
				min-height:100%;
			    min-width:100%;
			    width:auto;
			    height:auto;
			    position: absolute;
			    left: 50%;
			    top: 0;
			    transform: translate(-50%,0%);
			}
			img.center_bottom_slidepostion{
				min-height:100%;
			    min-width:100%;
			    width:auto;
			    height:auto;
			    position: absolute;
			    left: 50%;
			    bottom: 0;
			    transform: translate(-50%,0%);
			}
			#disable{
				display: none;
			}
			.disable li{
				display: block;
			}
			@-moz-document url-prefix() {
				.start-in i.fas, .stop-in i.fas {
			    	left: -2px!important;
				}
			}

			@media (min-width: 320px) and (max-width: 767px) {
	  		  	ul.position-image li{
					height: 100%;
				}
				/*#center_top_slidepostion{
					height: 100%;
				}
				#center_bottom_slidepostion{
					height: 100%;
				}*/
				.active .slide.current{
				    min-height: auto;
				}
				img.center_slidepostion{
					position: relative;
					left:0;
					top:0;
					transform: translate(0,0);
				}
				img.center_top_slidepostion{
					position: relative;
					left:0;
					top:0;
					transform: translate(0,0);
				}
				img.center_bottom_slidepostion{
					position: relative;
					left: 0;
					bottom:0;
					transform: translate(0,0);
				}
				ul.slidenav li:first-child {
					display: block!important;
				}
				ul.slidenav li {
					display: none;
				}
				.hide-navigation .slidenav button.start-in {
			        height: 26px!important;
			        width: 26px!important;
			    }
			}
			@media (min-width: 768px) and (max-width: 1005px) {
				ul.slidenav li:first-child {
					display: block!important;
				}
				ul.slidenav li {
					display: none;
				}
			}
			@media (min-width: 768px) and (max-width: 1024px) {
	 			ul.position-image li{
					height: 100%;
				}
				/*#center_top_slidepostion{
					height: 100%;
				}
				#center_bottom_slidepostion{
					height: 100%;
				}*/
				img.center_slidepostion{
					position: relative;
					left:0;
					top:0;
					transform: translate(0,0);
				}
				img.center_top_slidepostion{
					position: relative;
					left:0;
					top:0;
					transform: translate(0,0);
				}
				img.center_bottom_slidepostion{
					position: relative;
					left: 0;
					bottom:0;
					transform: translate(0,0);
				}
				.active .slide.current{
				    min-height: auto;
				}
			}
			</style>
			<script type="text/javascript">
				jQuery(document).ready(function(){

				!function(){
				  var w = window,
				  d = w.document;

				  if( w.onfocusin === undefined ){
				    d.addEventListener('focus' ,addPolyfill ,true);
				    d.addEventListener('blur' ,addPolyfill ,true);
				    d.addEventListener('focusin' ,removePolyfill ,true);
				    d.addEventListener('focusout' ,removePolyfill ,true);
				  }
				  function addPolyfill(e){
				    var type = e.type === 'focus' ? 'focusin' : 'focusout';
				    var event = new CustomEvent(type, { bubbles:true, cancelable:false });
				    event.c1Generated = true;
				    e.target.dispatchEvent( event );
				  }
				  function removePolyfill(e){
				if(!e.c1Generated){ // focus after focusin, so chrome will the first time trigger tow times focusin
				  d.removeEventListener('focus' ,addPolyfill ,true);
				  d.removeEventListener('blur' ,addPolyfill ,true);
				  d.removeEventListener('focusin' ,removePolyfill ,true);
				  d.removeEventListener('focusout' ,removePolyfill ,true);
				}
				setTimeout(function(){
				  d.removeEventListener('focusin' ,removePolyfill ,true);
				  d.removeEventListener('focusout' ,removePolyfill ,true);
				});
				}
				}();

				var myCarousel = (function() {
				  var carousel, slides, index, slidenav, settings, timer, setFocus, animationSuspended;
				  function forEachElement(elements, fn) {
				    for (var i = 0; i < elements.length; i++)
				      fn(elements[i], i);
				  }
				  function removeClass(el, className) {
				    if (el.classList) {
				      el.classList.remove(className);
				    } else {
				      el.className = el.className.replace(new RegExp('(^|\\b)' + className.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
				    }
				  }

				  function hasClass(el, className) {
				    if (el.classList) {
				      return el.classList.contains(className);
				    } else {
				      return new RegExp('(^| )' + className + '( |$)', 'gi').test(el.className);
				    }
				  }

				  function init(set) {
				    settings = set;
				    carousel = document.getElementById(settings.id);
				    slides = carousel.querySelectorAll('.slide');

				    carousel.className = 'active carousel';

				    var ctrls = document.createElement('ul');
				    
				    ctrls.className = 'controls';
				    ctrls.innerHTML = '<li>' +
				        '<button type="button" class="btn-prev" title="Previous Button" aria-label="Previous Slide"><img alt="Previous Item" src="<?php echo plugins_url(); ?>/ada-slider/prev.png" title="Previous Button"/></button>' +
				      '</li>' +
				      '<li>' +
				        '<button type="button" class="btn-next" title="Next Button" aria-label="Next Slide"><img alt="Next Item" src="<?php echo plugins_url(); ?>/ada-slider/next.png" /> </button>' +
				      '</li>';

				    ctrls.querySelector('.btn-prev')
				      .addEventListener('click', function () {
				        prevSlide(true);
				      });
				    ctrls.querySelector('.btn-next')
				      .addEventListener('click', function () {
				        nextSlide(true);
				      });

				    carousel.appendChild(ctrls);

				    if (settings.slidenav || settings.animate) {

				    	var disbale_navi = '<?php echo $class1; ?>';
				    	if (disbale_navi){
				      		slidenav = document.createElement('div');
				      	} else {
				      		slidenav = document.createElement('ul');
				      	}

				      slidenav.className = 'slidenav <?php echo $class1; ?>';

				      if (settings.animate) {
				      	if (disbale_navi){
				        	var li = document.createElement('div');
				        } else {
				        	var li = document.createElement('li');
				        }

				        if (settings.startAnimated) {
				          //li.innerHTML = '<button data-action="stop"><span class="visuallyhidden">Stop Animation </span>￭</button>';
				           //li.innerHTML = '<button class="start-in" data-action="stop"><span class="visuallyhidden">Stop Animation </span>||</button>';
									 li.innerHTML = '<button class="start-in fas fa-pause" data-action="stop"><span class="visuallyhidden">Stop Animation </span></button>';
				        } else {
				          li.innerHTML = '<button class="stop-in fas fa-play" data-action="start"><span class="visuallyhidden">Start Animation </span></button>';
				        }

				        slidenav.appendChild(li);
				      }
				      if (!disbale_navi){
					      if (settings.slidenav) {
					        forEachElement(slides, function(el, i){
					          var li = document.createElement('li');
					          var klass = (i===0) ? 'class="current" ' : '';
					          var kurrent = (i===0) ? ' <span class="visuallyhidden">(Current Item)</span>' : '';

					          li.innerHTML = '<button '+ klass +'data-slide="' + i + '" id="<?php echo $class1; ?>"><span class="visuallyhidden">News</span></button>';
					          slidenav.appendChild(li);
					        });
					      }
					   }

				      slidenav.addEventListener('click', function(event) {
				        var button = event.target;
				        if (button.localName == 'button') {
				          if (button.getAttribute('data-slide')) {
				            stopAnimation();
				            setSlides(button.getAttribute('data-slide'), true);
				          } else if (button.getAttribute('data-action') == "stop") {
				            stopAnimation();
				          } else if (button.getAttribute('data-action') == "start") {
				            startAnimation();
				          }
				        }
				      }, true);

				      carousel.className = 'active carousel with-slidenav';
				      carousel.appendChild(slidenav);
				    }

				    var liveregion = document.createElement('div');
				    liveregion.setAttribute('aria-live', 'polite');
				    liveregion.setAttribute('aria-atomic', 'true');
				    liveregion.setAttribute('class', 'liveregion visuallyhidden');
				    carousel.appendChild(liveregion);

				      slides[0].parentNode.addEventListener('transitionend', function (event) {
				        var slide = event.target;
				        removeClass(slide, 'in-transition');
				        if (hasClass(slide, 'current'))  {
				          if(setFocus) {
				            slide.setAttribute('tabindex', '-1');
				            slide.focus('data-slide');
				            setFocus = false;
				          }
				        }
				      });

				      carousel.addEventListener('mouseenter', suspendAnimation);
				      carousel.addEventListener('mouseleave', function(event) {
				        if (animationSuspended) {
				          startAnimation();
				        }
				      });

				      carousel.addEventListener('focusin', function(event) {
				        if (!hasClass(event.target, 'slide')) {
				          suspendAnimation();
				        }
				      });
				      carousel.addEventListener('focusout', function(event) {
				        if (!hasClass(event.target, 'slide') && animationSuspended) {
				          startAnimation();
				        }
				      });

				    index = 0;
				    setSlides(index);

				     if (settings.startAnimated) {
				     	var slidertime = '<?php echo $value->time_interval; ?>';
				      timer = setTimeout(nextSlide, slidertime);
				    }
				  }

				  function setSlides(new_current, setFocusHere, transition, announceItemHere) {
				    setFocus = typeof setFocusHere !== 'undefined' ? setFocusHere : false;
				    announceItem = typeof announceItemHere !== 'undefined' ? announceItemHere : false;
				    transition = typeof transition !== 'undefined' ? transition : 'none';

				    new_current = parseFloat(new_current);

				    var length = slides.length;
				    var new_next = new_current+1;
				    var new_prev = new_current-1;

				    if(new_next === length) {
				      new_next = 0;
				    } else if(new_prev < 0) {
				      new_prev = length-1;
				    }

				    for (var i = slides.length - 1; i >= 0; i--) {
				      slides[i].className = "slide";
				    }

				    slides[new_next].className = 'next slide' + ((transition == 'next') ? ' in-transition' : '');
				    slides[new_next].setAttribute('aria-hidden', 'true');

				    slides[new_prev].className = 'prev slide' + ((transition == 'prev') ? ' in-transition' : '');
				    slides[new_prev].setAttribute('aria-hidden', 'true');


				    slides[new_current].className = 'current slide';
				    slides[new_current].removeAttribute('aria-hidden');


				    if (announceItem) {
				      carousel.querySelector('.liveregion').textContent = 'Item ' + (new_current + 1) + ' of ' +   slides.length;
				    }

				    if(settings.slidenav) {
				      var buttons = carousel.querySelectorAll('.slidenav button[data-slide]');
				      for (var j = buttons.length - 1; j >= 0; j--) {
				        buttons[j].className = '';
								n = j+1;
				        buttons[j].innerHTML = '<span class="visuallyhidden">Slide '+n+'</span> ';
				      }
				      buttons[new_current].className = "current";
							m = new_current+1;
				      buttons[new_current].innerHTML = '<span class="visuallyhidden">Slide '+m+'</span><span class="visuallyhidden">(Current Item)</span>';
				    }

				    index = new_current;
				  }

				  function nextSlide(announceItem) {
				    announceItem = typeof announceItem !== 'undefined' ? announceItem : false;

				    var length = slides.length,
				    new_current = index + 1;

				    if(new_current === length) {
				      new_current = 0;
				    }

				    setSlides(new_current, false, 'prev', announceItem);

				    if (settings.animate) {
				    	var slidertime = '<?php echo $value->time_interval; ?>';
				      timer = setTimeout(nextSlide, slidertime);
				    }

				  }

				  function prevSlide(announceItem) {
				    announceItem = typeof announceItem !== 'undefined' ? announceItem : false;

				    var length = slides.length,
				    new_current = index - 1;

				    if(new_current < 0) {
				      new_current = length-1;
				    }

				    setSlides(new_current, false, 'next', announceItem);

				  }

				  function stopAnimation() {
				    clearTimeout(timer);
				    settings.animate = false;
				    animationSuspended = false;
				    _this = carousel.querySelector('[data-action]');
				    _this.innerHTML = '<span class="visuallyhidden">Start Animation </span>';
				    _this.setAttribute('data-action', 'start');
				  }

				  function startAnimation() {	
				    settings.animate = true;
				    animationSuspended = false;
				    var slidertime = '<?php echo $value->time_interval; ?>';
				    timer = setTimeout(nextSlide, slidertime);
				    _this = carousel.querySelector('[data-action]');
				   // _this.innerHTML = '<span class="visuallyhidden">Stop Animation </span>￭';
				   _this.innerHTML = '<span class="visuallyhidden">Stop Animation </span>';
				    _this.setAttribute('data-action', 'stop');
				  }

				  function suspendAnimation() {
				    if(settings.animate) {
				      clearTimeout(timer);
				      settings.animate = false;
				      animationSuspended = true;
				    }
				  }

				  return {
				    init:init,
				    next:nextSlide,
				    prev:prevSlide,
				    goto:setSlides,
				    stop:stopAnimation,
				    start:startAnimation
				  };
				});
				var c = new myCarousel();
				c.init({
				  id: 'c',
				  slidenav: true,
				  animate: true,
				  startAnimated: true
				});
			});
				jQuery(document).ready(function() {
				    var pageclass= jQuery('#ada_alider_hd').val();
				    if(pageclass ==1){
				        jQuery('body').addClass('ada_slider');
				    }
				});
				jQuery(document).ready(function(){
					jQuery('.slider-ada-width .start-in').click(function(){
						var d = jQuery(this).attr('data-action'); 
						if(d == 'stop'){
							jQuery('.slider-ada-width .fas').attr('data-action', 'stop');
							jQuery(".slider-ada-width .fas").removeClass("fa-play");
							jQuery(".slider-ada-width .fas").addClass("fa-pause");
							return false;
						} else if(d == 'start'){
							jQuery('.slider-ada-width .fas').attr('data-action', 'start');
							jQuery(".slider-ada-width .fas").removeClass("fa-pause");
							jQuery(".slider-ada-width .fas").addClass("fa-play");
							return false;
						}
					});
				});
				jQuery( "ul.slidenav" ).before('<span class="screen-reader-text" style="position:absolute; left:-999px;">Slide controls</span>');
			</script>
			<?php
			}			
			$html .= '</ul>';
			$html .= '</div>';
			$html .= '</div>';
			return $html;
		?>
<?php
	}
?>